%I je vstupni obraz z ktereho budu brat sbalonu
%stred je dvourozmerne pole s ulozenymi souradnicemi stredu okna
%okno je velikost vracene sablony
%uhel- je uhel o ktery bude STRED sablony orotovan
function [template]=GenTemplate(I,stred,okno,uhel)


%%%%SPATNE FUNGUJE
% 
% okno_shape2=ceil(okno*1.4142);%%zvetsim vyrez kvuli rotaci
% if(mod(okno_shape2,2)==1)
%     okno_shape2=okno_shape2-1;
% end
% 
% okno_shape2=okno_shape2/2;
% 
% t=I(stred(1)-okno_shape2:stred(1)+okno_shape2,stred(2)-okno_shape2:stred(2)+okno_shape2);
% 
% t=imrotate(t,uhel);
% 
% % w2=ceil((size(t,1)/2)+(okno/2)-1)-1;
% % w1=floor((size(t,1)/2)-(okno/2));
% % 
% % q2=ceil((size(t,2)/2)+(okno/2)-1)-1;
% % q1=floor((size(t,2)/2)-(okno/2));
% %template=t(w1:w2,q1:q2);
% 
% w2=((size(t,1)/2)+(okno/2)-1);
% w1=((size(t,1)/2)-(okno/2))-1;
% 
% q2=((size(t,2)/2)+(okno/2)-1);
% q1=((size(t,2)/2)-(okno/2))-1;
% template=t(w1:w2,q1:q2);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%vidim musi byt sude!
if(mod(okno,2)==1)
    okno=okno-1;
end
okno2=ceil(okno*1.4142);%%zvetsim vyrez kvuli rotaci

okno2=I(stred(1)-(okno2/2)+1:(okno2/2)+stred(1),stred(2)-(okno2/2)+1:(okno2/2)+stred(2));
oknoP=okno/2;
oknoP=int16(oknoP);


stred1=int16(size(okno2,1)/2);%%vypocet stredu obrazu ->pouziji pro vystrihnuti prostredku obrazu
stred2=int16(size(okno2,2)/2);
x=imrotate(okno2,uhel,'crop');
template=x(stred1-oknoP:stred1+oknoP-1,stred2-oknoP:stred2+oknoP-1);%vystriknu prostredek obrazu o rozmeru vidim
   
